class Pettanr.UsersController extends Pettanr.AppController
  
  # try getting current user
  test: () ->
    @user = new Pettanr.User.Session()  # ignore @form
    @listenTo(@user, 'sign_in:success', @sign_in_success)
    @listenTo(@user, 'sign_in:fail', @sign_in_fail)
    @user.save({})
  
  sign_in: () ->
    # form is Pettanr.User.Session
    @listenTo(@form, 'sign_in:success', @sign_in_success)
    @listenTo(@form, 'sign_in:fail', @sign_in_fail)
    @form.save({})
  
  sign_out: () ->
    @user = new Pettanr.User.Session()  # ignore @form
    @listenTo(@user, 'sign_out:success', @sign_out_success)
    @listenTo(@user, 'sign_out:fail', @sign_out_fail)
    @user.destroy()
  
  # header for guest
  guest: () ->
    view = new Pettanr.Views.User.Guest({})
    view.render()
    @trigger('ready', view)
  
  # header for signed in user
  account: () ->
    view = new Pettanr.Views.User.Account({})
    view.render()
    @trigger('ready', view)
  
  sign_in_success: (user, response) ->
    @trigger('success', user, response)
    @trigger('sign_in', user)
    @trigger('redirect', 'folders/root')
  
  sign_in_fail: (user, response) ->
    @trigger('fail', response)
  
  sign_out_success: (user, response) ->
    @trigger('success', user, response)
    @trigger('sign_out')
    @trigger('redirect', 'user_sessions/end')
  
  sign_out_fail: (user, response) ->
    @trigger('fail', response)
  
