class Pettanr.Views.Scroll.Show extends Pettanr.View.Show
  
  initialize: (options) ->
    @header = new Pettanr.View.Show.Header(@item, this, @binder_header_options())
    @authored_by = @item.authored_by()
    @owner = new Pettanr.View.Show.Footer(@item, this, @default_footer_options())
    @listenTo(@header, 'click:pick', @click_pick)
    @listenTo(@authored_by, 'click', @click_authored_by)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@header.render().el)
    this.$el.append(@authored_by.render().el)
    h3 = new Tag.H3({content: Pettanr.AppHelper.t_m('Scroll.description')})
    this.$el.append(h3.render().el)
    desc = new Tag.Div({content: @item.escape('description'), class_name: 'scroll-description'})
    this.$el.append(desc.render().el)
    label_button = new Pettanr.View.Button(@item.play_url(), I18n.t('scrolls.play.title'), {
      click: () =>
        @trigger('http_get', @item.play_url())
    })
    h2 = new Tag.H2({content: label_button.render().el})
    this.$el.append(h2.render().el)
    this.$el.append(@owner.render().el) if @item.is_own()
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
  click_pick: () ->
    @trigger('pick', @item)
  
  is_pickable: () ->
    true
  
  add_pick: (target_model) ->
    @header.add_pick(target_model)
  
