class Pettanr.Views.SpeechBalloon.NewElementLauncher extends Editor.EditorModule.DockModule.NewElementLauncher
  
  initialize: (options) ->
    super(options)
    @links_conf = {}
    _.extend(@links_conf, {
      template: {
        caption: 'Template',
        params: {
          controller: @model.pick_model().path_name(), action: 'index',
          page_size: 6, format: 'html'
        }
      }
    })
    _.extend(@links_conf, {
      inspire_recent: {
        caption: "Inspire recent item",
        params: {
          controller: @model.path_name(), action: 'index',
          page_size: 6, format: 'html'
        }
      }
    })
    if Pettanr.cache.operators.author
      _.extend(@links_conf, {
        inspire_my_recent: {
          caption: 'Inspire my recent item',
          params: {
            controller: @model.path_name(), action: 'by_author', id: Pettanr.cache.operators.author.get('id'), 
            page_size: 6, format: 'html'
          }
        }
      })
  
  render: () ->
    super()
    @add_links()
    this
  
  click_template: () ->
    @click_default(@links_conf.template.params)
  
  click_inspire_recent: () ->
    @click_default(@links_conf.inspire_recent.params)
  
  click_inspire_my_recent: () ->
    @click_default(@links_conf.inspire_my_recent.params)
  
class Pettanr.Views.SpeechBalloon.NewElement extends Pettanr.View
  
  initialize: (options) ->
    @parent = options.parent
    @target_model = options.target_model
    @pick_model = @target_model.pick_model()
  
  start: (@dialog, params) ->
    @dialog.start(@target_model, params, null)
    @listenTo(@dialog, 'pick', @pick)
    @trigger('dialog:open', @dialog)
  
  pick: (item) ->
    if item.item_name() == @target_model.item_name()
      # Inspire
      @listenTo(this, 'ready', @ready)
      item.get_child('balloon', this, {
        success: (balloon) =>
          item.get_child('speech', this, {
            success: (speech) =>
              new_item = new @target_model(item.attributes)
              new_item.unset('id', {silent: true})
              new_item.set({panel_id: @editor().item.get('id')}, {silent: true})
              new_balloon = balloon.clone()
              new_balloon.unset('id', {silent: true})
              new_balloon.unset('speech_balloon_id', {silent: true})
              new_speech = speech.clone()
              new_speech.unset('id', {silent: true})
              new_speech.unset('speech_balloon_id', {silent: true})
              new_item.boosts 'post'
              new_balloon.boosts 'post'
              new_speech.boosts 'post'
              new_item.set({balloon: new_balloon, speech: new_speech}, {silent: true})
              @trigger('ready', new_item)
          })
      })
    else if @target_model.is_traceable(item.item_name())
      # Trace
      item.trace_to(item.my_class().pick_item_name(), this, {
        success: (pick_item) => 
          @dialog.http_get(pick_item.show_url())
      })
    else if item.item_name() == @target_model.pick_item_name()
      # Pick
      @listenTo(this, 'ready', @ready)
      speech_balloon_template = item
      writing_format_list = Locmare.ListGroup.list(
        'writing_formats', 'index', {}
      )
      writing_format_list.open(this, {
        success: (writing_formats) => 
          writing_format = writing_formats[0]
          templates = {
            speech_balloon_template: speech_balloon_template,
            writing_format: writing_format
          }
          new_item = new @target_model()
          new_item.templates = templates
          new_item.set(new_item.pick(), {silent: true})
          new_item.boosts 'post'
          new_item.supply_default()
          # prepare balloon
          balloon = new Pettanr.Balloon()
          balloon.templates = templates
          balloon.set(balloon.pick(), {silent: true})
          balloon.boosts 'post'
          balloon.supply_default()
          # prepare speech
          speech = new Pettanr.Speech()
          speech.templates = templates
          speech.set(speech.pick(), {silent: true})
          speech.boosts 'post'
          speech.supply_default()
          # join elements
          new_item.set({balloon: balloon, speech: speech}, {silent: true})
          @trigger('ready', new_item)
      })
  
  ready: (new_item) ->
    @dialog.stop()
    @trigger('pick', new_item)
  
  dock: () ->
    @parent.dock()
  
  editor: () ->
    @dock().editor()
  
