class PicturesController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_action :authenticate_user, :only => []
    before_action :authenticate_author, :only => []
  else
    before_action :authenticate_user, :only => []
    before_action :authenticate_resource_reader, :only => [
      :show, :credit, :search
    ]
    before_action :authenticate_author, :only => []
  end
  before_action :authenticate_admin, :only => [:index, :by_artist ]
  
  def index
    filer_list
  end
  
  def by_artist
    filer_list param: params[:id]
  end
  
  def show_html_format format
    format.html {
      @item.boosts 'post'
      @picture = @item
    }
  end
  
  def show
    set_show
    respond_to do |format|
      opt = {:type => @item.mime_type, :disposition=>"inline"}
      format.png { send_data(@item.restore(params[:subdir]), opt ) }
      format.gif { send_data(@item.restore(params[:subdir]), opt ) }
      format.jpeg { send_data(@item.restore(params[:subdir]), opt ) }
      show_html_format format
      show_json_format format
      show_prof_format format
    end
  end
  
  def credit
    @picture = Picture.show(params[:id], @operators)
    
    respond_to do |format|
      format.html { render :layout => false }
      format.json { render :json => @picture.to_json}
    end
  end
  
  def search
    @pictures = Picture.find_by_md5(params[:md5])
    
    respond_to do |format|
      format.html
      format.json { render json: @pictures.to_json }
    end
  end
  
end
