class SheetsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_action :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  else
    before_action :authenticate_reader, :only => [
      :index, :show, :play, :by_story, :by_panel, :by_author
    ]
    before_action :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_story
    filer_list param: params[:id]
  end
  
  def by_panel
    filer_list param: params[:id]
  end
  
  def by_author
    filer_list param: params[:id]
  end
  
  def show_html_format format
    format.html {
      if @operators.author
        @new_panel_items = assist_items('home', 'panels', finder: :find_private, param: @operators)
        
        @new_story_items = assist_items('home', 'stories', finder: :find_private, param: @operators)
        @fresh_story_items = assist_items('home', 'story_sheets', finder: :find_private, param: @operators).map {|ss| ss.story}
      end
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format_for_root format
    end
  end
  
  def play
    set_play
    @finder.per(-1)    # no limit no pager
    play_list
    respond_to do |format|
      format.html {
        if @item.own? @operators
          @new_panel_items = assist_items('home', 'panels', finder: :find_private, param: @operators)
        end
      }
      list_json_format @finder, format
    end
  end
  
=begin
  def new
    set_new
    respond_to do |format|
      format.html {
        @editor = Editor::SheetEditor.new @item, @operators
        render :template => @editor.template_name, :locals => {
          :editor => @editor
        }
      }
      format.json { render json: @item.to_json }
    end
  end
  
  def edit
    set_edit
    respond_to do |format|
      format.html {
        @editor = Editor::SheetEditor.new @item, @operators
        render :template => @editor.template_name, :locals => {
          :editor => @editor
        }
      }
      format.json { render json: @item.to_json }
    end
  end
  
=end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
    @item.supply_default 
    @prm = if params[:json]
      JSON.parse_no_except(params[:json])
    else
      @item.permit_params params
    end
    
    respond_to do |format|
      if @item.store @prm, @operators
        created_html_format format
        created_json_format format
      else
        not_created_html_format format
        not_created_json_format format
      end
    end
  end
  
  def update
    set_edit
    jsn = nil
    @prm = if params[:json]
      JSON.parse(params[:json])
    else
      @item.permit_params params
    end
    respond_to do |format|
      if @item.store @prm, @operators
        updated_html_format format
        updated_json_format format
      else
        not_updated_html_format format
        not_updated_json_format format
      end
    end
  end
  
  def destroy
    set_model
    @item = @my_model_class.edit(params[:id], @operators)
    render_destroy '/home/' + @item.path_name
  end
  
end
