module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module IconItemColumnModule
            class Base
              attr :file_item, :icon_manifest, :item, :column_name
              
              def initialize file_item, icon_manifest, item
                @file_item = file_item
                @icon_manifest = icon_manifest
                @item = item
                @column_name = 'icon'
              end
              
              def filer
                @file_item.filer
              end
              
              def manifest
                self.filer.manifest
              end
              
              def item_name
                self.filer.item_name
              end
              
              def column_template_dir
                self.filer.template_dir + 'item_column/'
              end
              
              def column_template_file_name
                raise "undefined column_template_file_name\n"
              end
              
              def column_template_name
                self.column_template_dir + self.column_template_file_name
              end
              
              def item_template_dir
                self.filer.template_dir + 'icon/'
              end
              
              def item_template_file_name
                raise "undefined item_template_file_name\n"
              end
              
              def item_template_name
                self.item_template_dir + self.item_template_file_name
              end
              
            end
            
            class Default < Base
              def column_template_file_name
                'show'
              end
              
              def item_template_file_name
                'default'
              end
              
              def icon_file_name
                '/images/prof.gif'
              end
              
              def icon_size
                Manifest.manifest.magic_numbers['thumbnail_width']
              end
              
              def url
                controller_manifest = @item.class.my_controller
                action_manifest = controller_manifest.actions['show']
                action_manifest.url({'id' => @item.id.to_s, 'format' => 'prof'})
              end
              
            end
            
            class None < Base
              def column_template_file_name
                'none'
              end
              
            end
            
          end
        end
      end
    end
  end
end
