ManifestBase.require_modules "manifest/model/attribute/", 
  %w|source|

module Manifest
  module ModelModule
    class Attribute < ManifestBase::NameValues
      include AttributeModule
      
      attr :type, :primary_key, :rules, :source
      
      def set_default
        super
        ManifestBase.alert_undefined_message 'type',  self.module_message unless @values['type']
        @values['primary_key'] ||= 0
        @values['rules'] ||= {}
      end
      
      def init
        super
        @type = @values['type']  # do not remove
        @primary_key = @values['primary_key']
        @rules = @values['rules']
        if @values['source']
          @source = ManifestBase.load_type_args self, @values, 'source', SourceFactory
        end
      end
      
      def item_name
        @parent.item_name
      end
      
    end
    
  end
end
