module ManifestBase
  class Factory
    def self.types
      {}
    end
    
    def self.default_type
      nil
    end
    
    def self.factory parent, name, json, module_name
      module_message = ManifestBase.module_message(parent.module_names, [module_name, name])
      json['type'] ||= self.default_type
      type = json['type']
      ManifestBase.alert_undefined_message 'type', module_message unless type
      my_class = self.types[type]
      ManifestBase.alert_undefined_message 'class', module_message unless my_class
      my_class.new(parent, name, json, module_name)
    end
    
    def self.factory_type_args parent, json, module_name
      module_message = ManifestBase.module_message(parent.module_names, [module_name])
      json['type'] ||= self.default_type
      type = json['type']
      ManifestBase.alert_undefined_message 'type', module_message unless type
      my_class = self.types[type]
      ManifestBase.alert_undefined_message 'class', module_message unless my_class
      my_class.new(parent, json, module_name)
    end
    
  end
end

