# -*- encoding: utf-8 -*-
require 'spec_helper'
#コマ

describe Panel do
  include ManifestsMacros
  before do
    @model = Panel
  end
  
  describe 'ペタナイズに於いて' do
    it 'ルートである' do
      expect(@model.ancestors.include?(Peta::Root)).to eq true
    end
    it '親モデルは持たない' do
      expect(@model.my_peta.parent_model_name).to be_blank
    end
    describe 'ブーストに於いて' do
      it '特筆すべき注意事項はない' do
        expect(@model.my_peta.boost.keys).to be_empty
      end
    end
    
  end
  
  describe 'コントローラに於いて' do
    before do
      @controller = @model.my_controller
    end
    it 'コマのためのコントローラである' do
      expect(@model.item_name).to eq 'panel'
    end
    describe 'actionに於いて' do
      before do
        @actions = @controller.actions
        @actions_names = ['index', 'by_author', 'by_scroll', 'by_sheet', 'by_speech_balloon_template', 'show', 
          'count', 'count_by_author', 'count_by_scroll', 'count_by_sheet', 'count_by_speech_balloon_template', 
          'new', 'edit', 'create', 'update', 'destroy']
      end
      it 'これらのアクションが定義されている' do
        set_actions? @actions, @actions_names
      end
      describe 'baseに於いて' do
      end
      describe 'indexに於いて' do
        before do
          @action = @actions['index']
        end
        it 'listタイプのアクションである' do
          expect(@action.type).to eq 'list'
        end
        it 'マニフェストから設定を取り出している' do
          # コマの公開リストを返すように定義している
          set_list_action? @action, 'panel', 'public'
        end
      end
      describe 'by_authorに於いて' do
        before do
          @action = @actions['by_author']
        end
        it 'listタイプのアクションである' do
          expect(@action.type).to eq 'list'
        end
        it 'マニフェストから設定を取り出している' do
          # コマの作家フィルタリストを返すように定義している
          set_list_action? @action, 'panel', 'by_author'
        end
      end
      describe 'by_scrollに於いて' do
        before do
          @action = @actions['by_scroll']
        end
        it 'listタイプのアクションである' do
          expect(@action.type).to eq 'list'
        end
        it 'マニフェストから設定を取り出している' do
          #コマのコマフィルタリストを返すように定義している
          set_list_action? @action, 'panel', 'by_scroll'
        end
      end
      describe 'by_sheetに於いて' do
        before do
          @action = @actions['by_sheet']
        end
        it 'listタイプのアクションである' do
          expect(@action.type).to eq 'list'
        end
        it 'マニフェストから設定を取り出している' do
          #コマのコマフィルタリストを返すように定義している
          set_list_action? @action, 'panel', 'by_sheet'
        end
      end
      describe 'by_speech_balloon_templateに於いて' do
        before do
          @action = @actions['by_speech_balloon_template']
        end
        it 'listタイプのアクションである' do
          expect(@action.type).to eq 'list'
        end
        it 'マニフェストから設定を取り出している' do
          #コマのコマフィルタリストを返すように定義している
          set_list_action? @action, 'panel', 'by_speech_balloon_template'
        end
      end
      describe 'showに於いて' do
        before do
          @action = @actions['show']
        end
        it 'showタイプのアクションである' do
          expect(@action.type).to eq 'show'
        end
      end
      describe 'countに於いて' do
        before do
          @action = @actions['count']
        end
        it 'countタイプのアクションである' do
          expect(@action.type).to eq 'count'
        end
        it 'マニフェストから設定を取り出している' do
          #コマの公開リストのカウントを返すように定義している
          set_list_action? @action, 'panel', 'public'
        end
      end
      describe 'count_by_authorに於いて' do
        before do
          @action = @actions['count_by_author']
        end
        it 'countタイプのアクションである' do
          expect(@action.type).to eq 'count'
        end
        it 'マニフェストから設定を取り出している' do
          # コマの作家フィルタリストのカウントを返すように定義している
          set_list_action? @action, 'panel', 'by_author'
        end
      end
      describe 'count_by_scrollに於いて' do
        before do
          @action = @actions['count_by_scroll']
        end
        it 'countタイプのアクションである' do
          expect(@action.type).to eq 'count'
        end
        it 'マニフェストから設定を取り出している' do
          # コマのコマフィルタリストのカウントを返すように定義している
          set_list_action? @action, 'panel', 'by_scroll'
        end
      end
      describe 'count_by_sheetに於いて' do
        before do
          @action = @actions['count_by_sheet']
        end
        it 'countタイプのアクションである' do
          expect(@action.type).to eq 'count'
        end
        it 'マニフェストから設定を取り出している' do
          # コマのコマフィルタリストのカウントを返すように定義している
          set_list_action? @action, 'panel', 'by_sheet'
        end
      end
      describe 'count_by_speech_balloon_templateに於いて' do
        before do
          @action = @actions['count_by_speech_balloon_template']
        end
        it 'countタイプのアクションである' do
          expect(@action.type).to eq 'count'
        end
        it 'マニフェストから設定を取り出している' do
          # コマのコマフィルタリストのカウントを返すように定義している
          set_list_action? @action, 'panel', 'by_speech_balloon_template'
        end
      end
      describe 'newに於いて' do
        before do
          @action = @actions['new']
        end
        it 'newタイプのアクションである' do
          expect(@action.type).to eq 'new'
        end
        it 'type' do
          expect(@action.item_name).to eq 'panel'
        end
      end
      describe 'editに於いて' do
        before do
          @action = @actions['edit']
        end
        it 'editタイプのアクションである' do
          expect(@action.type).to eq 'edit'
        end
        it 'type' do
          expect(@action.item_name).to eq 'panel'
        end
      end
      describe 'createに於いて' do
        before do
          @action = @actions['create']
        end
        it 'createタイプのアクションである' do
          expect(@action.type).to eq 'create'
        end
        it 'type' do
          expect(@action.item_name).to eq 'panel'
        end
      end
      describe 'updateに於いて' do
        before do
          @action = @actions['update']
        end
        it 'updateタイプのアクションである' do
          expect(@action.type).to eq 'update'
        end
        it 'type' do
          expect(@action.item_name).to eq 'panel'
        end
      end
      describe 'destroyに於いて' do
        before do
          @action = @actions['destroy']
        end
        it 'destroyタイプのアクションである' do
          expect(@action.type).to eq 'destroy'
        end
        it 'type' do
          expect(@action.item_name).to eq 'panel'
        end
      end
    end
    
  end
  
  describe 'モデルに於いて' do
    before do
      @my_manifest = @model.my_manifest
    end
    it 'サポート機能が動作している' do
      expect(@my_manifest.model_name).to eq 'panel'
      expect(@my_manifest.classify).to eq @model
      expect(@my_manifest.table_name).to eq 'panels'
    end
    
    describe 'associationsに於いて' do
      describe 'belongs_toに於いて' do
        before do
          @belongs_to = @my_manifest.associations.belongs_to
          @names = ['author']
        end
        it 'これらのモデルに所属している' do
          set_associations? @belongs_to, @names
        end
        describe 'authorに於いて' do
          before do
            @mani = @belongs_to['author']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名と外部キーが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'author'
            expect(@mani.id_column).to eq 'author_id'
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている
            expect(@mani.model).to eq Author
          end
        end
      end
      describe 'has_manyに於いて' do
        before do
          @has_many = @model.my_manifest.associations.has_many
          @names = ['scroll_panels', 'scrolls', 'sheet_panels', 'sheets', 
          'panel_pictures', 'speech_balloons', 'ground_pictures', 'ground_colors']
        end
        it 'これらのモデルを所持している' do
          set_associations? @has_many, @names
        end
        describe 'scroll_panelsに於いて' do
          before do
            @mani = @has_many['scroll_panels']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'scroll_panel'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to be nil
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be false
            expect(@mani.model).to eq ScrollPanel
          end
        end
        describe 'scrollsに於いて' do
          before do
            @mani = @has_many['scrolls']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'scroll'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to eq 'scroll_panels'
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be true
            expect(@mani.model).to eq Scroll
          end
        end
        describe 'sheet_panelsに於いて' do
          before do
            @mani = @has_many['sheet_panels']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'sheet_panel'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to be nil
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be false
            expect(@mani.model).to eq SheetPanel
          end
        end
        describe 'sheetsに於いて' do
          before do
            @mani = @has_many['sheets']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'sheet'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to eq 'sheet_panels'
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be true
            expect(@mani.model).to eq Sheet
          end
        end
        describe 'panel_picturesに於いて' do
          before do
            @mani = @has_many['panel_pictures']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'panel_picture'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to be nil
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be false
            expect(@mani.model).to eq PanelPicture
          end
        end
        describe 'speech_balloonsに於いて' do
          before do
            @mani = @has_many['speech_balloons']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'speech_balloon'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to be nil
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be false
            expect(@mani.model).to eq SpeechBalloon
          end
        end
        describe 'ground_picturesに於いて' do
          before do
            @mani = @has_many['ground_pictures']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'ground_picture'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to be nil
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be false
            expect(@mani.model).to eq GroundPicture
          end
        end
        describe 'ground_colorsに於いて' do
          before do
            @mani = @has_many['ground_colors']
          end
          it 'マニフェストから設定を取り出している' do
            # モデル名, 外部キーと中間モデルが定義あるいはデフォルト値補充されている
            expect(@mani.model_name).to eq 'ground_color'
            expect(@mani.foreign_key).to eq 'panel_id'
            expect(@mani.through).to be nil
          end
          it 'サポート機能が動作している' do
            # モデルを再現できている, 中間モデルフラグ
            expect(@mani.through?).to be false
            expect(@mani.model).to eq GroundColor
          end
        end
      end
    end
    
    describe 'attributesに於いて' do
      before do
        @attributes = @model.my_manifest.attributes
      end
      it 'これらのカラムを定義している' do
        set_attributes? @attributes, 
          ['id', 'width', 'height', 'border', 'caption', 'publish', 'author_id', 
          'created_at', 'updated_at']
      end
      describe 'widthに於いて' do
        before do
          @attribute = @attributes['width']
        end
        it 'numberタイプである' do
          expect(@attribute.type).to eq 'number'
        end
      end
      describe 'heightに於いて' do
        before do
          @attribute = @attributes['height']
        end
        it 'numberタイプである' do
          expect(@attribute.type).to eq 'number'
        end
      end
      describe 'borderに於いて' do
        before do
          @attribute = @attributes['border']
        end
        it 'numberタイプである' do
          expect(@attribute.type).to eq 'number'
        end
      end
      describe 'captionに於いて' do
        before do
          @attribute = @attributes['caption']
        end
        it 'textタイプである' do
          expect(@attribute.type).to eq 'text'
        end
      end
      describe 'publishに於いて' do
        before do
          @attribute = @attributes['publish']
        end
        it 'numberタイプである' do
          expect(@attribute.type).to eq 'number'
        end
        it '選択肢を定数から取得できるように定義している' do
          expect(@attribute.source.type).to eq 'magic_number'
          expect(@attribute.source.select_item_name).to eq 'panel_publish_items'
        end
      end
      describe 'author_idに於いて' do
        before do
          @attribute = @attributes['author_id']
        end
        it 'numberタイプである' do
          expect(@attribute.type).to eq 'number'
        end
      end
    end
    
  end
  
end
